#
# Copyright (C) 2018  Sage Vaillancourt, sagev9000@gmail.com
#
# This file is part of Fronter.
# 
# Fronter is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
# 
# Fronter is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License
# along with Fronter.  If not, see <http://www.gnu.org/licenses/>.
#

extends Node

signal refund
signal speed_upgrade
signal bullet_delay_upgrade
signal double_laser_upgrade
signal add_laser
signal plasma_lasers
signal menu_closed
signal change_color
signal taste_the_rainbow

var bullet_delay_tier
var shooting_speed_tier
var double_lasers

func _ready():
	bullet_delay_tier = get_parent().bullet_delay_tier
	$ShootingSpeedUpgrade/Icon.frame = bullet_delay_tier
	if get_tree().has_network_peer():
		$ColorRect.color = Color(1,1,1,0.5)
	else:
		$ColorRect.color = Color(0,0,0,1)

func _process(delta):
	$ShootingSpeedUpgrade/Icon.frame = bullet_delay_tier
	if (Input.is_action_pressed("ui_quit")):
		get_tree().quit()
	if Input.is_action_pressed("ui_accept"):
		_on_Button_pressed()

func _on_Button_pressed():
	get_tree().paused = false
	emit_signal("menu_closed")
	queue_free()

func _on_Refund_pressed():
	bullet_delay_tier = 0
	$ShootingSpeedUpgrade/Icon.frame = 0
	get_tree().paused = false
	emit_signal("refund")

func _on_ShootingSpeedUpgrade_pressed():
	get_tree().paused = false
	emit_signal("bullet_delay_upgrade")
	bullet_delay_tier = get_parent().bullet_delay_tier

func _on_DoubleLaserUpgrade_pressed():
	get_tree().paused = false
	emit_signal("double_laser_upgrade")
	prints("UPGRADE SHIP SPEED SIGNAL EMITTED")

func _on_Goldenrod_pressed():
	emit_signal("change_color", "daa520")

func _on_Purple_pressed():
	emit_signal("change_color", "800080")

func _on_SlateBlue_pressed():
	emit_signal("change_color", "708090")

func _on_Salmon_pressed():
	emit_signal("change_color", "e9967a")

func _on_Crimson_pressed():
	emit_signal("change_color", "dc143c")

func _on_MediumSpringGreen_pressed():
	emit_signal("change_color", "3cb371")

func _on_Tomato_pressed():
	emit_signal("change_color", "ff3e2d")
	prints("put tomato in dere")

func _on_DarkenedLawnGreen_pressed():
	emit_signal("change_color", "7bd126")

func _on_DeepSkyBlue_pressed():
	emit_signal("change_color", "00bfff")

#### NOT PAUSING GAME? ####
func _on_Rainbow_pressed():
	get_tree().paused = false
	emit_signal("taste_the_rainbow")
